/*
//	Description: Demo CAN Functions
//	File:		CANTest.cpp
//	Created:	Christian Apfel
//	Date:		26.04.2017
//
*/

#include "stdafx.h"
#include "CANTest.h"
#include <iostream>

using namespace std;

CANTest::CANTest()
{

}

CANTest::~CANTest()
{

}

// ****** Demo App Menu Functions ******

void CANTest::StartCanTest()
{
	int CAN_TEST;
	int CAN_DEV_MODE;
	int CAN_DEV_ID;
	unsigned long CAN_DEV_FREQ;
	int CAN_DEV_MSG_PRIO;
	int CAN_DEV_MSG_COUNT;
	int CAN_DEV_MSG_PACKET_COUNT;
	int CAN_DEV_FILTER_ID;
	int CAN_DEV_FILTER_ID_MASK;
	int CAN_DEV_TIMEOUT;
	int CAN_DEV_WRITE_DELAY;
	int CAN_DEV_MESSAGE_LENGTH;
	unsigned char CAN_SEND_DATA[50];
	unsigned char CAN_RECEIVE_DATA[50];
	unsigned char CAN_RECEIVE_PACKET_DATA[8];
	char *cStatus = new char[20];
	int iBytePackets = 0;
	int iByteLength = 0;
	unsigned long lDev_Bitrate;
		
	// Wait Loop for 0 to Exit
	do
	{
		memset(CAN_SEND_DATA, 0, sizeof(CAN_SEND_DATA));
		memset(CAN_RECEIVE_DATA, 0, sizeof(CAN_RECEIVE_DATA));
		iByteLength = 0;
		cout << "---------------------------------" << endl;
		cout << "Select CAN Test!" << endl;
		cout << "---------------------------------" << endl;
		cout << "1: Write Test" << endl;
		cout << "2: Read Test" << endl;
		cout << "3: Remote Write Test" << endl;
		cout << "4: Remote Read Test" << endl;
		cout << "5: Filter Write Test" << endl;
		cout << "6: Filter Read Test" << endl;
		cout << "7: Async Read/Write Test" << endl;
		cout << "0: Main Menu" << endl;
		cout << "---------------------------------" << endl;
		cout << "Enter Test Number: ";
		cin >> CAN_TEST;

		switch(CAN_TEST)
		{
		case 1:
			{
				cout << endl;
				cout << "CAN Write Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN ID (CAN ID: 11bit -> max 0x1FF, 29bit -> max 0xFFFFFF ): ";
				cin >> std::hex >> CAN_DEV_ID;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN Message PRIO (0 ... 255): ";
				cin >> CAN_DEV_MSG_PRIO;
				cout << "Enter CAN Data (e.g. abc): ";
				cin >> CAN_SEND_DATA;
				//cout << "Enter CAN Data Length (1 ... 8): ";
				//cin >> CAN_DEV_MSG_COUNT;

				if(CANWriteTest(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, CAN_DEV_ID, CAN_DEV_MSG_PRIO, CAN_DEV_MSG_COUNT, CAN_SEND_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "CAN Write Test - Data: " << CAN_SEND_DATA << " Status: " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 2:
			{
				cout << endl;
				cout << "CAN Read Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN Data Length (1 ... 50): ";
				cin >> CAN_DEV_MSG_COUNT;

				if(CANReadTest(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, &CAN_DEV_ID, CAN_DEV_MSG_COUNT, CAN_RECEIVE_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				CAN_DEV_MSG_PACKET_COUNT = CAN_DEV_MSG_COUNT / 8;

				if((CAN_DEV_MSG_COUNT % 8) > 0)
				{
					CAN_DEV_MSG_PACKET_COUNT++;
				}

				for(int i = 0; i < CAN_DEV_MSG_PACKET_COUNT; i++)
				{
					memset(CAN_RECEIVE_PACKET_DATA, 0, sizeof(CAN_RECEIVE_PACKET_DATA));

					for(int j = 0; j < 8; j++)
					{
						CAN_RECEIVE_PACKET_DATA[j] = CAN_RECEIVE_DATA[iByteLength];
						iByteLength = iByteLength + 1;
					}

					wcout << "CAN Read Test - ID: 0x" << std::hex << CAN_DEV_ID << " - Data: 0x" << std::hex << CAN_RECEIVE_PACKET_DATA[0] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[1] << " 0x" << std::hex << CAN_RECEIVE_PACKET_DATA[2] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[3] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[4] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[5] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[6] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[7] << " Status: " << cStatus << "!!!" << endl;
				}
				cout << "------------------------------------" << endl;
			}
			break;
		case 3:
			{
				cout << endl;
				cout << "CAN Remote Write Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN ID (CAN ID: 11bit -> max 0x1FF, 29bit -> max 0xFFFFFF ): ";
				cin >> std::hex >> CAN_DEV_ID;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN Message PRIO (0 ... 255): ";
				cin >> CAN_DEV_MSG_PRIO;
				//cout << "Enter CAN Data (e.g. abc): ";
				//cin >> CAN_SEND_DATA;
				cout << "Enter CAN Data Length (1 ... 8): ";
				cin >> CAN_DEV_MSG_COUNT;

				if(CANRemoteWriteTest(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, CAN_DEV_ID, CAN_DEV_MSG_PRIO, CAN_DEV_MSG_COUNT, CAN_SEND_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "CAN Remote Write Test - Data: " << CAN_SEND_DATA << " Status: " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 4:
			{
				cout << endl;
				cout << "CAN Remote Read Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN Data Length (1 ... 50): ";
				cin >> CAN_DEV_MSG_COUNT;

				if(CANRemoteReadTest(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, &CAN_DEV_ID, CAN_DEV_MSG_COUNT, CAN_RECEIVE_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				CAN_DEV_MSG_PACKET_COUNT = CAN_DEV_MSG_COUNT / 8;

				if((CAN_DEV_MSG_COUNT % 8) > 0)
				{
					CAN_DEV_MSG_PACKET_COUNT++;
				}

				for(int i = 0; i < CAN_DEV_MSG_PACKET_COUNT; i++)
				{
					for(int j = 0; j < 8; j++)
					{
						memset(CAN_RECEIVE_PACKET_DATA, 0, sizeof(CAN_RECEIVE_PACKET_DATA));
						CAN_RECEIVE_PACKET_DATA[j] = CAN_RECEIVE_DATA[iByteLength];
						iByteLength = iByteLength + 1;
					}

					wcout << "CAN Remote Read Test - ID: 0x" << std::hex << CAN_DEV_ID << " - Data: 0x" << std::hex << CAN_RECEIVE_PACKET_DATA[0] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[1] << " 0x" << std::hex << CAN_RECEIVE_PACKET_DATA[2] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[3] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[4] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[5] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[6] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[7] << " Status: " << cStatus << "!!!" << endl;
				}
				cout << "------------------------------------" << endl;
			}
			break;
		case 5:
			{
				cout << endl;
				cout << "CAN Filter Write Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN ID (CAN ID: 11bit -> max 0x1FF, 29bit -> max 0xFFFFFF ): ";
				cin >> std::hex >> CAN_DEV_ID;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN Message PRIO (0 ... 255): ";
				cin >> CAN_DEV_MSG_PRIO;
				cout << "Enter CAN Message Filter (e.g. 0x25): ";
				cin >> std::hex >> CAN_DEV_FILTER_ID;
				cout << "Enter CAN Message Filter ID Mask (e.g. 0x1FF): ";
				cin >> std::hex >> CAN_DEV_FILTER_ID_MASK;
				//cout << "Enter CAN Data (e.g. abc): ";
				//cin >> CAN_SEND_DATA;
				cout << "Enter CAN Data Length (1 ... 8): ";
				cin >> CAN_DEV_MSG_COUNT;

				if(CANFilterWriteTest(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, CAN_DEV_ID, CAN_DEV_MSG_PRIO, CAN_DEV_FILTER_ID, CAN_DEV_FILTER_ID_MASK, CAN_DEV_MSG_COUNT, CAN_SEND_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "CAN Filter Write Test - Data: " << CAN_SEND_DATA << " Status: " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 6:
			{
				cout << endl;
				cout << "CAN Filter Read Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN Message Filter (e.g. 0x25): ";
				cin >> std::hex >> CAN_DEV_FILTER_ID;
				cout << "Enter CAN Message Filter ID Mask (e.g. 0x1FF): ";
				cin >> std::hex >> CAN_DEV_FILTER_ID_MASK;
				cout << "Enter CAN Data Length (1 ... 50): ";
				cin >> CAN_DEV_MSG_COUNT;

				if(CANFilterReadTest(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, &CAN_DEV_ID, CAN_DEV_FILTER_ID, CAN_DEV_FILTER_ID_MASK, CAN_DEV_MSG_COUNT, CAN_RECEIVE_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				CAN_DEV_MSG_PACKET_COUNT = CAN_DEV_MSG_COUNT / 8;

				if((CAN_DEV_MSG_COUNT % 8) > 0)
				{
					CAN_DEV_MSG_PACKET_COUNT++;
				}

				for(int i = 0; i < CAN_DEV_MSG_PACKET_COUNT; i++)
				{
					for(int j = 0; j < 8; j++)
					{
						memset(CAN_RECEIVE_PACKET_DATA, 0, sizeof(CAN_RECEIVE_PACKET_DATA));
						CAN_RECEIVE_PACKET_DATA[j] = CAN_RECEIVE_DATA[iByteLength];
						iByteLength = iByteLength + 1;
					}

					wcout << "CAN Filter Read Test - ID: 0x" << std::hex << CAN_DEV_ID << " - Data: 0x" << std::hex << CAN_RECEIVE_PACKET_DATA[0] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[1] << " 0x" << std::hex << CAN_RECEIVE_PACKET_DATA[2] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[3] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[4] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[5] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[6] << " 0x"<< std::hex << CAN_RECEIVE_PACKET_DATA[7] << " Status: " << cStatus << "!!!" << endl;
				}
				cout << "------------------------------------" << endl;
			}
			break;
		case 7:
			{
				cout << endl;
				cout << "CAN Async Read/Write Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter CAN Mode (CAN Mode: 0 = Standard, 1 = Extended ): ";
				cin >> CAN_DEV_MODE;
				cout << "Enter CAN Frequency (20000 ... 1000000 (Bit/s)): ";
				cin >> std::dec >> CAN_DEV_FREQ;
				cout << "Enter CAN ID (CAN ID: 11bit -> max 0x1FF, 29bit -> max 0xFFFFFF ): ";
				cin >> std::hex >> CAN_DEV_ID;
				cout << "Enter CAN Write Data (e.g. abc): ";
				cin >> std::hex >> CAN_SEND_DATA;
				cout << "Enter CAN Read Data Length (1 ... 8): ";
				cin >> CAN_DEV_MSG_COUNT;
				cout << "Enter CAN Timeout (e.g. 1000 = 1s (msec)): ";
				cin >> CAN_DEV_TIMEOUT;
				cout << "Enter CAN Write Loop Delay (e.g. 1000 = 1s (msec)): ";
				cin >> CAN_DEV_WRITE_DELAY;

				if(AsyncronousReadWrite(DHCOM_CANModeEnum(CAN_DEV_MODE), CAN_DEV_FREQ, CAN_DEV_ID, false, CAN_DEV_MSG_COUNT, CAN_SEND_DATA, CAN_DEV_TIMEOUT, CAN_DEV_WRITE_DELAY) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "CAN Async Read/Write Test - Status: " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 0:
			{
				return;
			}
			break;
		default:
			{

			}
			break;
		}
	}while(1);
}

// ****** UART Functions ******

bool CANTest::CANWriteTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int iCANID, unsigned char cCANPrio, int iCount, unsigned char *cData)
{
	bool bTLPrio = false;
	ulong lMsgTimeout = 30000;
	bool bTXAbort = true;
	unsigned char cSendArray[50];
	int iDataLength = 0;
	int iByteCount = 0;
	//int iPacketLength = 0;

	memset(cSendArray, 0, sizeof(cSendArray));

	// Calculate Buffer length
	iDataLength = strlen((const char*)cData);

	for(int i = 0; i < iDataLength; i++)
	{
		cSendArray[i] = ((cData[iByteCount] & 0xF) << 4) | (cData[iByteCount+1] & 0xF);
		//cout << "DHCOM can data: 0x" << std::hex << cSendArray[i] << endl;
		iByteCount = iByteCount + 2;
	}

	// Calculate Message Buffer length
	iDataLength = strlen((const char*)cSendArray);

	/*for(int i = 0; i < iCount; i++)
	{
		cSendArray[i] = 0xff;
		wcout << "DHCOM can data: 0x" << cSendArray[i] << endl;
	}*/

	if(CANOpen(DHCOM_CAN1) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lCANBitrate, bTLPrio, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_DATA, iCANID, cCANPrio, lMsgTimeout, bTXAbort) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANWrite(DHCOM_CAN1, cSendArray, iDataLength, NULL) == true)
		{
			CANClose(DHCOM_CAN1);
			return true;
		}

		CANClose(DHCOM_CAN1);
	}

	cout << "CAN Write Test failed";

	return false;
}

bool CANTest::CANReadTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int *iCANID, int iCount, unsigned char *cData)
{
	bool bTLPrio = false;
	ulong lMsgTimeout = 30000;
	int iDefMsgID = 0;
	bool bTXAbort = false;
	unsigned char cCANPrio = 0;
	int iFilterID = 0;
	int iFilterIDMask = 0;
	bool bFilterFormat = false;
	bool bFilterRemote = false;

	if(CANOpen(DHCOM_CAN1) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lCANBitrate, bTLPrio, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_DATA, iDefMsgID, cCANPrio, lMsgTimeout, bTXAbort) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureFilter(DHCOM_CAN1, iFilterID, iFilterIDMask, bFilterFormat, bFilterRemote) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}         

 		if(CANRead(DHCOM_CAN1, cData, iCount, NULL) == true)
		{
			CANClose(DHCOM_CAN1);

			CANGetMessageParameter(DHCOM_CAN1, iCANID);

			return true;
		}

		CANClose(DHCOM_CAN1);
	}

	cout << "CAN Read Test failed";

	return false;
}

bool CANTest::CANRemoteWriteTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int iCANID, unsigned char cCANPrio, int iCount, unsigned char *cData)
{
	bool bTLPrio = false;
	ulong lMsgTimeout = 30000;
	bool bTXAbort = true;
	unsigned char cSendArray[50];
	int iDataLength = 0;
	int iByteCount = 0;
	int iPacketLength = 0;

	memset(cSendArray, 0, sizeof(cSendArray));

	/*
	// Calculate Buffer length
	iDataLength = strlen((const char*)cData);

	for(int i = 0; i < iDataLength; i++)
	{
		cSendArray[i] = ((cData[iByteCount] & 0xF) << 4) | (cData[iByteCount+1] & 0xF);
		iByteCount = iByteCount + 2;
	}

	// Calculate Message Buffer length
	iDataLength = strlen((const char*)cSendArray);
	iPacketLength = iDataLength / 8;

	// if data length written to next array
	if((iDataLength % 8) > 0)
	{
		iPacketLength++;
	}*/

	for(int i = 0; i < iCount; i++)
	{
		cSendArray[i] = 0xff;
	}

	if(CANOpen(DHCOM_CAN1) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lCANBitrate, bTLPrio, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_REMOTE, iCANID, cCANPrio, lMsgTimeout, bTXAbort) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANWrite(DHCOM_CAN1, cData, iPacketLength, NULL) == true)
		{
			CANClose(DHCOM_CAN1);
			return true;
		}

		CANClose(DHCOM_CAN1);
	}

	cout << "CAN Remote Write Test failed";

	return false;
}

bool CANTest::CANRemoteReadTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int *iCANID, int iCount, unsigned char *cData)
{
	bool bTLPrio = false;
	ulong lMsgTimeout = 30000;
	int iDefMsgID = 0;
	bool bTXAbort = false;
	unsigned char cCANPrio = 0;
	int iFilterID = 0;
	int iFilterIDMask = 0;
	bool bFilterFormat = false;
	bool bFilterRemote = true;

	if(CANOpen(DHCOM_CAN1) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lCANBitrate, bTLPrio, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_DATA, iDefMsgID, cCANPrio, lMsgTimeout, bTXAbort) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureFilter(DHCOM_CAN1, iFilterID, iFilterIDMask, bFilterFormat, bFilterRemote) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANRead(DHCOM_CAN1, cData, iCount, NULL) == true)
		{
			CANGetMessageParameter(DHCOM_CAN1, iCANID);

			CANClose(DHCOM_CAN1);
			return true;
		}

		CANClose(DHCOM_CAN1);
	}

	cout << "CAN Remote Read Test failed";

	return false;
}

bool CANTest::CANFilterWriteTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int iCANID, unsigned char cCANPrio, int iCANFilterID, int iCANFilterIDMask, int iCount, unsigned char *cData)
{
	bool bTLPrio = false;
	ulong lMsgTimeout = 30000;
	int iFilterIDMask = 0x1FF;
	bool bFilterFormat = false;
	bool bFilterRemote = false;
	bool bTXAbort = true;
	unsigned char cSendArray[50];
	int iDataLength = 0;
	int iByteCount = 0;
	int iPacketLength = 0;

	memset(cSendArray, 0, sizeof(cSendArray));

	/*
	// Calculate Buffer length
	iDataLength = strlen((const char*)cData);

	for(int i = 0; i < iDataLength; i++)
	{
		cSendArray[i] = ((cData[iByteCount] & 0xF) << 4) | (cData[iByteCount+1] & 0xF);
		iByteCount = iByteCount + 2;
	}

	// Calculate Message Buffer length
	iDataLength = strlen((const char*)cSendArray);
	iPacketLength = iDataLength / 8;

	// if data length written to next array
	if((iDataLength % 8) > 0)
	{
		iPacketLength++;
	}
	*/

	for(int i = 0; i < iCount; i++)
	{
		cSendArray[i] = 0xff;
	}

	if(CANOpen(DHCOM_CAN1) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lCANBitrate, bTLPrio, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureFilter(DHCOM_CAN1, iCANFilterID, iFilterIDMask, bFilterFormat, bFilterRemote) == false)
		{
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_DATA, iCANID, cCANPrio, lMsgTimeout, bTXAbort) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANWrite(DHCOM_CAN1, cData, iPacketLength, NULL) == true)
		{
			if(CANResetFilter(DHCOM_CAN1) == true)
			{
				CANClose(DHCOM_CAN1);
				return true;
			}
		}

		CANClose(DHCOM_CAN1);
	}

	cout << "CAN Filter Write Test failed";

	return false;
}

bool CANTest::CANFilterReadTest(DHCOM_CANModeEnum eCANMode, unsigned long lCANBitrate, int *iCANID, int iCANFilterID, int iCANFilterIDMask, int iCount, unsigned char *cData)
{
	bool bTLPrio = false;
	ulong lMsgTimeout = 30000;
	int iDefMsgID = 0;
	bool bTXAbort = true;
	unsigned char cCANPrio = 0;
	bool bFilterFormat = false;
	bool bFilterRemote = false;

	if(CANOpen(DHCOM_CAN1) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lCANBitrate, bTLPrio, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_DATA, iDefMsgID, cCANPrio, lMsgTimeout, bTXAbort) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureFilter(DHCOM_CAN1, iCANFilterID, iCANFilterIDMask, bFilterFormat, bFilterRemote) == false)
		{
			return false;
		}

		if(CANRead(DHCOM_CAN1, cData, iCount, NULL) == true)
		{
			if(CANResetFilter(DHCOM_CAN1) == true)
			{
				CANGetMessageParameter(DHCOM_CAN1, iCANID);

				CANClose(DHCOM_CAN1);
				return true;
			}
		}

		CANClose(DHCOM_CAN1);
	}

	cout << "CAN Filter Read Test failed";

	return false;
}

bool CANTest::AsyncronousReadWrite(DHCOM_CANModeEnum eCANMode, unsigned long lBitRate, int iID, bool bPRIO, int iDataLength, unsigned char *cData, unsigned long lTimeout, int iDelay)
{
	HANDLE  hReadThread;
	DWORD   dwReadThreadId;
	PCANDATA pDataRead;
	DWORD dwExitCode;
	HANDLE  hWriteThread;
	DWORD   dwWriteThreadId;
	PCANDATA pDataWrite;
	unsigned char cReceiveData[8];
	unsigned char cWriteData[8];
	int iWriteDataLength = 0;
	int iByteCount = 0;
	int keyToWaitFor = VK_SPACE;

	int iFilterID = 0;
	int iFilterIDMask = 0;
	bool bFilterFormat = false;
	bool bFilterRemote = false;

	memset(cReceiveData, 0, sizeof(cReceiveData));
	memset(cWriteData, 0, sizeof(cWriteData));

	iWriteDataLength = strlen((const char*)cData);

	for(int i = 0; i < iDataLength; i++)
	{
		cWriteData[i] = ((cData[iByteCount] & 0xF) << 4) | (cData[iByteCount+1] & 0xF);
		iByteCount = iByteCount + 2;
	}

	// Calculate Message Buffer length
	iWriteDataLength = strlen((const char*)cWriteData);

	/*
	for(int i = 0; i < iDataLength; i++)
	{
		cWriteData[i] = 0xff;
	}
	*/

    // Allocate memory for thread data.

    pDataRead = (PCANDATA) HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(CANDATA));
	pDataWrite = (PCANDATA) HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(CANDATA));
	
	if( pDataRead == NULL)
    {
        // If the array allocation fails, the system is out of memory
        // so there is no point in trying to print an error message.
        // Just terminate execution.
        ExitProcess(2);
    }

	if( pDataWrite == NULL)
    {
        // If the array allocation fails, the system is out of memory
        // so there is no point in trying to print an error message.
        // Just terminate execution.
        ExitProcess(2);
    }

    // Generate unique data for each thread to work with.

	pDataRead->pData = cReceiveData;
	pDataRead->DataLength = iDataLength;

	pDataWrite->pData = cWriteData;
	pDataWrite->DataLength = iWriteDataLength;
	pDataWrite->TXLoopDelay = iDelay;

	if(CANOpen(DHCOM_CAN1) == true)
	{
		if(CANConfigureMode(DHCOM_CAN1, eCANMode, lBitRate, bPRIO, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_DATA, iID, bPRIO, lTimeout, false) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		if(CANConfigureMessage(DHCOM_CAN1, DHCOM_CAN_DATA, iID, bPRIO, lTimeout, true) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}

		// Must set for reading data from CAN bus, other read function fails
		if(CANConfigureFilter(DHCOM_CAN1, iFilterID, iFilterIDMask, bFilterFormat, bFilterRemote) == false)
		{
			CANClose(DHCOM_CAN1);
			return false;
		}
	}
    // Create the thread to begin execution on its own.

	if(iDataLength > 0)
	{
		bEnabled = true;

		hReadThread = CreateThread( 
            NULL,                   // default security attributes
            0,                      // use default stack size  
            CAN_READ_THREAD,	    // thread function name
            pDataRead,		    // argument to thread function 
            0,                      // use default creation flags 
            &dwReadThreadId);   // returns the thread identifier 

		hReadThread = CreateThread( 
            NULL,                   // default security attributes
            0,                      // use default stack size  
            CAN_WRITE_THREAD,	    // thread function name
            pDataWrite,		    // argument to thread function 
            0,                      // use default creation flags 
            &dwWriteThreadId);   // returns the thread identifier
	}
	else
	{
		cout << "CAN read data size error" << endl;
		return false;
	}

    // Check the return value for success.
    // If CreateThread fails, terminate execution. 
    // This will automatically clean up threads and memory. 

    if (hReadThread == NULL || hWriteThread == NULL) 
    {
		CanErrorHandler(TEXT("CreateCANThread"));
		ExitProcess(3);
    }

	do
	{
		if (GetAsyncKeyState(keyToWaitFor)!=0){
			bEnabled = false;
			//TerminateThread(hReadThread, dwExitCode);
			//TerminateThread(hWriteThread, dwExitCode);
			CloseHandle(hReadThread);
			CloseHandle(hWriteThread);
			CANClose(DHCOM_CAN1);
			Sleep(1000);
			break;
		}
	}while(1);

	if(pDataRead != NULL)
    {
        HeapFree(GetProcessHeap(), 0, pDataRead);
	}

	if(pDataWrite != NULL)
    {
        HeapFree(GetProcessHeap(), 0, pDataWrite);
	}

	return true;
}

DWORD WINAPI CAN_READ_THREAD( LPVOID lpParam )
{
	PCANDATA pDataRead;

	pDataRead = (PCANDATA)lpParam;

	int iCount = 0;
	int iResult = 0;

	while(bEnabled == true)
	{
		//CANRead(DHCOM_CAN1, pDataRead->pData, pDataRead->DataLength);

		//printf("CAN Read Length: %d - Data: 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x\n", pDataRead->DataLength, pDataRead->pData[0], pDataRead->pData[1], pDataRead->pData[2], pDataRead->pData[3], pDataRead->pData[4], pDataRead->pData[5], pDataRead->pData[6], pDataRead->pData[7]);

		if(CANRead(DHCOM_CAN1, pDataRead->pData, pDataRead->DataLength, &iResult) == true)
		{
  			printf("CAN Read Count: %d | Length: %d | Data: 0x%x,0x%x,0x%x,0x%x,0x%x,0x%x,0x%x,0x%x\n", iCount, pDataRead->DataLength, pDataRead->pData[0], pDataRead->pData[1], pDataRead->pData[2], pDataRead->pData[3], pDataRead->pData[4], pDataRead->pData[5], pDataRead->pData[6], pDataRead->pData[7]);
		}
		else
		{
			//pDataRead->Result = iResult;
			printf("CAN Read Error: %d\n", iResult);
		}   

		iCount++;
	}

	return 0;
}

DWORD WINAPI CAN_WRITE_THREAD( LPVOID lpParam )
{
	PCANDATA pDataWrite;

	pDataWrite = (PCANDATA)lpParam;

	int iCount = 0;
	int iResult = 0;

	while(bEnabled == true)
	{
		if(CANWrite(DHCOM_CAN1, pDataWrite->pData, pDataWrite->DataLength, &iResult) == true)
		{  
  			printf("CAN Write Count: %d | Length: %d | Data: 0x%x,0x%x,0x%x,0x%x,0x%x,0x%x,0x%x,0x%x\n", iCount, pDataWrite->DataLength, pDataWrite->pData[0], pDataWrite->pData[1], pDataWrite->pData[2], pDataWrite->pData[3], pDataWrite->pData[4], pDataWrite->pData[5], pDataWrite->pData[6], pDataWrite->pData[7]);
		}
		else
		{
			//pDataRead->Result = iResult;
			printf("CAN Write Error: %d\n", iResult);
		}

		iCount++;
		Sleep(pDataWrite->TXLoopDelay);
	}

	return 0;
}

void CanErrorHandler(LPTSTR lpszFunction) 
{ 
    // Retrieve the system error message for the last-error code.

    LPVOID lpMsgBuf;
    LPVOID lpDisplayBuf;
    DWORD dw = GetLastError(); 

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0, NULL );

    // Display the error message.

    lpDisplayBuf = (LPVOID)LocalAlloc(LMEM_ZEROINIT, 
        (lstrlen((LPCTSTR) lpMsgBuf) + lstrlen((LPCTSTR) lpszFunction) + 40) * sizeof(TCHAR)); 
    StringCchPrintf((LPTSTR)lpDisplayBuf, 
        LocalSize(lpDisplayBuf) / sizeof(TCHAR),
        TEXT("%s failed with error %d: %s"), 
        lpszFunction, dw, lpMsgBuf); 
    MessageBox(NULL, (LPCTSTR) lpDisplayBuf, TEXT("Error"), MB_OK); 

    // Free error-handling buffer allocations.

    LocalFree(lpMsgBuf);
    LocalFree(lpDisplayBuf);
}
