/*
//	Description: Demo Version Functions
//	File:		VersionTest.cpp
//	Created:	Christian Apfel
//	Date:		20.01.2016
//
*/

#include "stdafx.h"
#include "VersionTest.h"

using namespace std;

VersionTest::VersionTest()
{

}

VersionTest::~VersionTest()
{

}

// ****** Demo App Menu Functions ******

void VersionTest::StartVersionTest()
{
	int VERSION_TEST;
	unsigned long DHHALLIB_VERSION = DHHalLibGetVersion();
	unsigned long BSP_VERSION = BSPGetVersion();
	unsigned long IMAGE_VERSION = WinCEImageGetVersion();
	char *cStatus = new char[20];

	// Wait Loop for 0 to Exit
	do
	{
		cout << "---------------------------------" << endl;
		cout << "Select Version Test!" << endl;
		cout << "---------------------------------" << endl;
		cout << "1: Get DHHalLib Version Test" << endl;
		cout << "2: Get BSP Version Test" << endl;
		cout << "3: Get WinCE Image Version Test" << endl;
		cout << "0: Main Menu" << endl;
		cout << "---------------------------------" << endl;
		cout << "Enter Test Number: ";
		cin >> VERSION_TEST;

		switch(VERSION_TEST)
		{
		case 1:
			{
				cout << endl;
				cout << "Get DHHalLib Version Test" << endl;
				cout << "------------------------------------" << endl;

				DHHALLIB_VERSION = GetDHHalLibVersion();

				int ivalue[4];
				ivalue[3] = DHHALLIB_VERSION & 0xFF;
				ivalue[2] = (DHHALLIB_VERSION >> 8) & 0xFF;
				ivalue[1] = (DHHALLIB_VERSION >> 16) & 0xFF;
				ivalue[0] = (DHHALLIB_VERSION >> 24) & 0xFF;
				
				cout << "-------------------------------------" << endl;
				printf("DHHalLib Version: %x.%x.%x.%x", ivalue[0], ivalue[1], ivalue[2], ivalue[3]);
			}
			break;
		case 2:
			{
				cout << endl;
				cout << "Get BSP Version Test" << endl;
				cout << "------------------------------------" << endl;

				BSP_VERSION = GetBSPVersion();

				int ivalue[4];
				ivalue[3] = BSP_VERSION & 0xFF;
				ivalue[2] = (BSP_VERSION >> 8) & 0xFF;
				ivalue[1] = (BSP_VERSION >> 16) & 0xFF;
				ivalue[0] = (BSP_VERSION >> 24) & 0xFF;

				cout << "-------------------------------------" << endl;
				printf("BSP Version: %x.%x.%x.%x", ivalue[0], ivalue[1], ivalue[2], ivalue[3]);
			}
			break;
		case 3:
			{
				cout << endl;
				cout << "Get WinCE Image Version Test" << endl;
				cout << "------------------------------------" << endl;
				
				IMAGE_VERSION = GetIMAGEVersion();

				int ivalue[4];
				ivalue[3] = IMAGE_VERSION & 0xFF;
				ivalue[2] = (IMAGE_VERSION >> 8) & 0xFF;
				ivalue[1] = (IMAGE_VERSION >> 16) & 0xFF;
				ivalue[0] = (IMAGE_VERSION >> 24) & 0xFF;
				
				cout << "-------------------------------------" << endl;
				printf("WinCE Image Version: %x.%x.%x.%x", ivalue[0], ivalue[1], ivalue[2], ivalue[3]);
			}
			break;
		case 0:
			{
				delete(cStatus);
				return;
			}
		default:
			{
				cout << "Not valid Test Function!!!" << endl;
			}
			break;
		}
	}while(1);
}

// ****** Version Functions ******

int VersionTest::GetDHHalLibVersion()
{
	unsigned long DHHALLIB_VERSION = DHHalLibGetVersion();

	return (int)DHHALLIB_VERSION;
}

int VersionTest::GetBSPVersion()
{
	unsigned long BSP_VERSION = BSPGetVersion();

	return (int)BSP_VERSION;
}

int VersionTest::GetIMAGEVersion()
{
	unsigned long IMAGE_VERSION = WinCEImageGetVersion();

	return (int)IMAGE_VERSION;
}
